# ConfigSeeder Value Provider

## General Information

This Helm Chart allows to install the ConfigSeeder extension value provider. 

Additional Information about ConfigSeeder and its features can be retrieved at the following locations:

* https://www.configseeder.com
* https://configseeder.com/documentation/

### Intendend use

This specific Helm Chart installs the ConfigSeeder extension value provider. The value provider allows to gain high
availability in accessing configuration data stored in ConfigSeeder.

This Helm Chart comes without a complete configuration and therefore must be configured manually.

## Configuring ConfigSeeder

### Default configuration

This Helm Chart comes only partially configured, the following configuration is missing / has to be done by you:

* Provide the private and public key for jwt encryption (use same values as used in ConfigSeeder management)
* Provide an encryption secret (use same values as used in ConfigSeeder management)
* Provide the URL for accessing ConfigSeeder
* Provide a secret containing an API Key for accessing ConfigSeeder

### Replacing the default `application.yml`

An individual `application.yml` can be provided with the helm's `--set-file` argument:

```
helm --kube-context=${context} -n "$ns" template value-provider configseeder-value-provider \
     --values <your-values>.yaml \
     --set-file application_configuration=./<your-application.yml> \
     | kubectl --context=${context} -n "$ns" apply -f -
```

You can find an overview of all configuration options in our documentation.

### Replacing the default jwt encryption key and encryption secret

The default encryption credentials can be overwritten with the following options in your values file:

```
configseeder:
  encryptionSecret: "...encryptionSecret..."
  jwtPublicKey: "...jwt-public-key..."
```

The tool for creating the keys can be downloaded from our [website](https://configseeder.com/download), look for _ConfigSeeder Util_.

## Configuring Kubernetes specifics
  
### Enabling PSP

The Helm Chart comes with disabled Pod Security Policies. PSP can be activated with the following options in your values.file:

```
psp:
  create: true
  name: configseeder-value-provider
  existingPspClusterRole: psp:restricted
```

Please be aware that no PodSecurityPolicy will be created by the chart. The name of a ClusterRole has to be provided, the chart will create a 
RoleBinding to this already existing ClusterRole.